     H Option(*SrcStmt : *NoDebugIO)  DftActgrp(*No) BndDir('CGIBNDDIR')

     FPRODUCT2  IF   E           K DISK
     FCATEGOR1  IF   E           K DISK

     D XML_Output      S            256a   Varying
     D                                     Inz('/Partner400/MCTools.xml')

     D lastCategory    S                   Like(CATCOD)
     D firstRecord     S               n   Inz(*on)

     D rc              S             10i 0

       // Copy in CGIDEV2 prototypes and the standard API error structure
      /Copy PrototypeB

      /Copy USEC

      /Free

       // Load HTML Template then write initial section
       //   This includes the DTD for the XML file.

       GetHTMLIFS('/Partner400/ProdTempl.xml');

       WrtSection('FILEHEADER');

       Read PRODUCT2;

       Dow Not %Eof(PRODUCT2);

         // If category has changed get category description
         //   and output category header and trailer if needed

         If CATCOD <> lastCategory;

           If Not firstrecord;
             WrtSection('CategoryTrailer');  // Not written on first record
           Else;
             firstRecord = *Off;
           EndIf;

           lastCategory = CATCOD;

           Chain CATCOD CATEGOR1;

           UpdHTMLVar('CatCode': CATCOD);
           UpdHTMLVar('CatName': CATDES);

           WrtSection('CategoryHeader');

         EndIf;

          // Now set up product information and write it to buffer

         UpdHTMLVar('ProdCode': PRODCD);
         UpdHTMLVar('Description': PRODDS);
         UpdHTMLVar('SellPrice': %Char(SELLPR));
         UpdHTMLVar('CostPrice': %Char(LNDCST));
         UpdHTMLVar('QtyOnHand': %Char(STOH));

         WrtSection('ProductData');

         Read PRODUCT2;

       EndDo;

       // All records in file have been processed - output trailers and
       //   write the completed HTML to the output file

       WrtSection('CategoryTrailer FileTrailer');

       rc = WrtHtmlToStmf(XML_Output: 819);

       *InLR = *On;
 